"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _components = require("./components");

require("./ReactFileUploader.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getFileType = function getFileType(fileName) {
  var splitedUrl = fileName && fileName.split('.') || [];
  var fileType = splitedUrl.pop();
  return fileType;
};

var ReactFileUploader =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ReactFileUploader, _React$PureComponent);

  function ReactFileUploader(props) {
    var _this;

    _classCallCheck(this, ReactFileUploader);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ReactFileUploader).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "cropImage", function (cropper) {
      _this.setState({
        showLoader: true
      }, function () {
        var url = cropper.getCroppedCanvas().toDataURL();
        cropper.getCroppedCanvas().toBlob(function (blob) {
          var file = new File([blob], _this.state.file.name, {
            type: _this.state.file.type
          });

          _this.setState({
            file: file,
            url: url
          }, function () {
            _this.handleUploadFile();
          });
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "openModal", function () {
      _this.setState({
        modalOpened: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "closeModal", function () {
      _this.setState({
        modalOpened: false,
        showLoader: false,
        url: ''
      }, function () {
        _this.fileInput.value = '';
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange",
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(event) {
        var file, url, imageExtensions, fileName, fileType, isImage;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                file = event.target.files[0];
                url = URL.createObjectURL(file);
                imageExtensions = ['jpg', 'jpeg', 'png'];
                fileName = event.target.files[0].name;
                fileType = getFileType(fileName);
                isImage = imageExtensions.indexOf(fileType) >= 0;

                _this.setState({
                  file: file,
                  fileType: isImage ? 'image' : 'other',
                  url: url
                }, function () {
                  if (isImage) {
                    _this.openModal();
                  } else {
                    _this.handleUploadFile();
                  }
                });

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(_assertThisInitialized(_this), "handleUploadFile", function () {
      _this.setState({
        showLoader: true
      },
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _this$state, file, fileType, handleUploadFile;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$state = _this.state, file = _this$state.file, fileType = _this$state.fileType;
                handleUploadFile = _this.props.handleUploadFile;

                if (!(typeof handleUploadFile === 'function')) {
                  _context2.next = 7;
                  break;
                }

                _context2.next = 5;
                return _this.props.handleUploadFile(file, fileType);

              case 5:
                _context2.next = 8;
                break;

              case 7:
                console.warn('handleUploadFile function is undefined');

              case 8:
                _this.closeModal();

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      })));
    });

    _defineProperty(_assertThisInitialized(_this), "renderLoader", function () {
      if (_this.props.customLoader) {
        return _this.props.customLoader;
      }

      return _react["default"].createElement(_components.Loader, null);
    });

    _this.state = {
      file: null,
      fileType: 'other',
      modalOpened: false,
      showLoader: false,
      url: ''
    };
    _this.fileInput = null;
    return _this;
  }

  _createClass(ReactFileUploader, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          accept = _this$props.accept,
          children = _this$props.children,
          _this$props$label = _this$props.label,
          label = _this$props$label === void 0 ? 'Click to upload file' : _this$props$label,
          _this$props$style = _this$props.style,
          style = _this$props$style === void 0 ? {} : _this$props$style,
          _this$props$uploadBut = _this$props.uploadButtonLabel,
          uploadButtonLabel = _this$props$uploadBut === void 0 ? 'Upload file' : _this$props$uploadBut;
      var _this$state2 = this.state,
          showLoader = _this$state2.showLoader,
          url = _this$state2.url,
          modalOpened = _this$state2.modalOpened;
      return _react["default"].createElement("div", {
        className: "ReactFileUploader"
      }, modalOpened && _react["default"].createElement("div", {
        className: "CropperModalBackground",
        onClick: this.closeModal
      }), _react["default"].createElement("label", {
        className: children ? 'Label' : 'Label Default'
      }, !children && label, children, _react["default"].createElement("input", {
        accept: accept,
        className: "UploadInput",
        onChange: function onChange(e) {
          return _this2.handleChange(e);
        },
        ref: function ref(_ref3) {
          _this2.fileInput = _ref3;
        },
        type: "file"
      })), modalOpened && _reactDom["default"].createPortal(_react["default"].createElement(_components.UploaderModal, {
        closeModal: this.closeModal,
        handleUploadFile: this.cropImage,
        uploadButtonStyle: style.uploadButtonStyle,
        uploadButtonLabel: uploadButtonLabel,
        url: url
      }), document.querySelector('#uploader-modal')), showLoader && this.renderLoader());
    }
  }]);

  return ReactFileUploader;
}(_react["default"].PureComponent);

ReactFileUploader.propTypes = {
  accept: _propTypes["default"].string,
  customLoader: _propTypes["default"].any,
  handleUploadFile: _propTypes["default"].func.isRequired,
  label: _propTypes["default"].string,
  style: _propTypes["default"].object,
  uploadButtonLabel: _propTypes["default"].string
};
var _default = ReactFileUploader;
exports["default"] = _default;
