var webpack = require('webpack');
var path = require('path');

module.exports = {
  mode: 'development',
  entry: [
    "@babel/polyfill",
    'webpack-dev-server/client?http://localhost:3000',
    'webpack/hot/only-dev-server',
    path.join(__dirname, 'example/src/index.js'),
  ],
  output: {
    path: path.join(__dirname, 'example/assets'),
    filename: 'bundle.js',
    publicPath: '/assets/',
  },
  module: {
    rules: [
      {
        test: /\.jsx?$/,
        loaders: [
          'react-hot-loader/webpack',
          'babel-loader',
        ],
        include: path.join(__dirname),
        exclude: [
          /node_modules/,
        ],
      },
      {
        test: /\.s?css$/,
        include: path.join(__dirname),
        use: [
          'style-loader',
          'css-loader',
          'sass-loader',
        ],
      },
      {
        test: /\.(gif|png|jpe?g|svg)$/i,
        use: [
          'file-loader',
          {
            loader: 'image-webpack-loader',
          },
        ],
      },
    ],
  },
  resolve: {
    extensions: ['.js', '.jsx'],
  },
  plugins: [
    new webpack.HotModuleReplacementPlugin(),
  ],
};
